/**
  *********************************************************************
  * @file    main.c
  * @author  liaodeyun
  * @version V1.0
  * @date    2025-7-6
  * @brief   RT-Thread 3.0 + STM32 Ȼ
  *********************************************************************
  * @attention
  *
  * ʵƽ̨:Ұ H750 PRO STM32  
  * ̳    :http://www.firebbs.cn
  * Ա    :https://fire-stm32.taobao.com
  *
  **********************************************************************
  */ 

/*
*************************************************************************
*                             ͷļ
*************************************************************************
*/ 
#include "board.h"
#include "rtthread.h"

#include <stdio.h>
#include "NGCal.h"
#include "Therm.h"
#include "Detail.h"
#include "FlowCal.h"

/*
*************************************************************************
*                               
*************************************************************************
*/
/* ߳̿ƿ */
static rt_thread_t OFlowCal_thread = RT_NULL;
static rt_thread_t key_thread = RT_NULL;
/*
*************************************************************************
*                             
*************************************************************************
*/
static void OFlowCal_thread_entry(void* parameter);
static void key_thread_entry(void* parameter);

/*
*************************************************************************
*                             main 
*************************************************************************
*/
/**
  * @brief  
  * @param  
  * @retval 
  */
int main(void)
{	
    /* 
	 * ӲʼRTTϵͳʼѾmain֮ǰɣ
	 * component.cļеrtthread_startup()ˡ
	 * mainУֻҪ̺̼߳߳ɡ
	 */
  rt_kprintf("һ[Ұ]-STM32H750Ȼʵ\n\n");
  rt_kprintf("K1̣߳K2ָ߳\n");
	OFlowCal_thread =                          /* ߳̿ƿָ */
    rt_thread_create( "OFlowCal",              /* ߳ */
                      OFlowCal_thread_entry,   /* ߳ں */
                      RT_NULL,             /* ߳ں */
                      512,                 /* ߳ջС */
                      3,                   /* ̵߳ȼ */
                      20);                 /* ߳ʱƬ */
                   
    /* ̣߳ */
   if (OFlowCal_thread != RT_NULL)
        rt_thread_startup(OFlowCal_thread);
    else
        return -1;
    
  key_thread =                          /* ߳̿ƿָ */
    rt_thread_create( "key",              /* ߳ */
                      key_thread_entry,   /* ߳ں */
                      RT_NULL,             /* ߳ں */
                      512,                 /* ߳ջС */
                      2,                   /* ̵߳ȼ */
                      20);                 /* ߳ʱƬ */
                   
    /* ̣߳ */
   if (key_thread != RT_NULL)
        rt_thread_startup(key_thread);
    else
        return -1;
}

/*
*************************************************************************
*                             ̶߳
*************************************************************************
*/

static void OFlowCal_thread_entry(void* parameter)
{	
  
    while (1)
    {
       
			 // ʼṹ
    FlowParSTRUCT flowParams = {0};
    NGParSTRUCT ngParams = {0};
    
    // û
    flowParams.dPatm = 0.0981;       // ׼ѹ(bar)
    flowParams.dPf = 1.48;            // ѹ(MPa)
    flowParams.dPfType = 0;           // 0=ѹ1=ѹ
    flowParams.dDp = 12.50;            // ѹ(kPa)
    flowParams.dTf = 15.0;            // ¶(C)
    flowParams.dCbtj = 0;             // α(0=׼״̬)
    
    // ùܵ
    flowParams.dPipeD = 259.38;        // ܵھ(mm)
    flowParams.dOrificeD = 150.25;      // װ׾(mm)
    flowParams.dPipeType = 0;         // ܵ
    flowParams.dPtmode = 0;           // ȡѹʽ(0=ȡѹ1=ǽȡѹ)
    
    // òϲ
    flowParams.dPipeMaterial = 2;     // 20Ÿ
    flowParams.dOrificeMaterial = 10;   // Ͻ
    
    // Ȼ(ʾ: 95%飬5%)
   // ʼȻ(GB/T 21446-2008 ʾ)
for(int i=0; i<NUMBEROFCOMPONENTS; i++) {
    flowParams.dNG_Compents[i] = 0.0;  // ȫʼΪ0
}

// GB/T 21446-2008׼еȻֵָ(ٷֱ)
flowParams.dNG_Compents[0] = 88.36;   // (CH4)
flowParams.dNG_Compents[1] = 0.68;    // (N2)
flowParams.dNG_Compents[2] = 1.57;    // ̼(CO2)
flowParams.dNG_Compents[3] = 6.25;    // (C2H6)
flowParams.dNG_Compents[4] = 2.4;    // (C3H8)
flowParams.dNG_Compents[5] = 0.00;    // ˮ(H2O)
flowParams.dNG_Compents[6] = 0.00;    // (H2S)
flowParams.dNG_Compents[7] = 0.04;    // (H2)
flowParams.dNG_Compents[8] = 0.00;    // һ̼(CO)
flowParams.dNG_Compents[9] = 0.00;    // (O2)
flowParams.dNG_Compents[10] = 0.15;   // 춡(i-C4H10)
flowParams.dNG_Compents[11] = 0.35;   // (n-C4H10)
flowParams.dNG_Compents[12] = 0.05;   // (i-C5H12)
flowParams.dNG_Compents[13] = 0.1;   // (n-C5H12)
flowParams.dNG_Compents[14] = 0.01;   // (C6H14)
flowParams.dNG_Compents[15] = 0.0;   // (C7H16)
flowParams.dNG_Compents[16] = 0.0;   // (C8H18)
flowParams.dNG_Compents[17] = 0.0;   // (C9H20)
flowParams.dNG_Compents[18] = 0.0;   // (C10H22)
flowParams.dNG_Compents[19] = 0.04;   // (He)
flowParams.dNG_Compents[20] = 0.0;   // 

    
    // 㺯
    OFlowCal(&flowParams, &ngParams);
    
    // ӡ
    printf("==========  ==========\n");
    printf(": %.4f m3/s\n", flowParams.dVFlowf);
    printf(": %.4f m3/s\n", flowParams.dVFlowb);
    printf(": %.4f kg/s\n", flowParams.dMFlowb);
    printf(": %.4f MJ/s\n", flowParams.dEFlowb / 1e6);
    printf("ܵ: %.2f m/s\n", flowParams.dVelocityFlow);
    printf("ϵ: %.4f\n", flowParams.dCd);
    printf("ŵ: %.2f\n", flowParams.dRnPipe);
    
 			
			
			
    }
}

static void key_thread_entry(void* parameter)
{	
  rt_err_t uwRet = RT_EOK;	
    while (1)
    {
      if( Key_Scan(KEY1_GPIO_PORT,KEY1_PIN) == KEY_ON )/* K1  */
      {
        printf("LED1̣߳\n");
        uwRet = rt_thread_suspend(OFlowCal_thread);/* LED1߳ */
        if(RT_EOK == uwRet)
        {
          rt_kprintf("LED1̳߳ɹ\n");
        }
        else
        {
          rt_kprintf("LED1߳ʧܣʧܴ룺0x%lx\n",uwRet);
        }
      } 
      if( Key_Scan(KEY2_GPIO_PORT,KEY2_PIN) == KEY_ON )/* K1  */
      {
        printf("ָLED1̣߳\n");
        uwRet = rt_thread_resume(OFlowCal_thread);/* ָLED1̣߳ */
        if(RT_EOK == uwRet)
        {
          rt_kprintf("ָLED1̳߳ɹ\n");
        }
        else
        {
          rt_kprintf("ָLED1߳ʧܣʧܴ룺0x%lx\n",uwRet);
        }
      }
      rt_thread_delay(20);
    }
}




/********************************END OF FILE****************************/
